/// @cond EO_CXX_EO_IMPL

inline bool elm::slider::horizontal_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_horizontal_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::slider::horizontal_set(bool horizontal_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_horizontal_set(::efl::eolian::to_c(horizontal_)));
}

inline double elm::slider::value_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_value_get());
   return _tmp_ret;
}

inline void elm::slider::value_set(double val_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_value_set(val_));
}

inline ::efl::eina::optional< ::efl::eina::string_view > elm::slider::indicator_format_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_format_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::slider::indicator_format_set(::efl::eina::optional< ::efl::eina::string_view > indicator_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_indicator_format_set(::efl::eolian::to_c(indicator_)));
}

inline bool elm::slider::inverted_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_inverted_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::slider::inverted_set(bool inverted_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_inverted_set(::efl::eolian::to_c(inverted_)));
}

inline bool elm::slider::indicator_show_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_show_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::slider::indicator_show_set(bool show_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_indicator_show_set(::efl::eolian::to_c(show_)));
}

inline void elm::slider::min_max_get(double* min_, double* max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_min_max_get(min_, max_));
}

inline void elm::slider::min_max_set(double min_, double max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_min_max_set(min_, max_));
}

inline ::efl::eina::optional< ::efl::eina::string_view > elm::slider::unit_format_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_unit_format_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::slider::unit_format_set(::efl::eina::optional< ::efl::eina::string_view > units_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_unit_format_set(::efl::eolian::to_c(units_)));
}

inline bool elm::slider::indicator_show_on_focus_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_show_on_focus_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::slider::indicator_show_on_focus_set(bool flag_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_indicator_show_on_focus_set(::efl::eolian::to_c(flag_)));
}

inline Evas_Coord elm::slider::span_size_get() const
{
   Evas_Coord _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_span_size_get());
   return _tmp_ret;
}

inline void elm::slider::span_size_set(Evas_Coord size_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_span_size_set(size_));
}

inline double elm::slider::step_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_step_get());
   return _tmp_ret;
}

inline void elm::slider::step_set(double step_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_step_set(step_));
}

inline Elm_Slider_Indicator_Visible_Mode elm::slider::indicator_visible_mode_get() const
{
   Elm_Slider_Indicator_Visible_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_visible_mode_get());
   return _tmp_ret;
}

inline void elm::slider::indicator_visible_mode_set(Elm_Slider_Indicator_Visible_Mode indicator_visible_mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_indicator_visible_mode_set(indicator_visible_mode_));
}

inline void elm::slider::indicator_format_function_set(slider_func_type func_, slider_freefunc_type free_func_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_indicator_format_function_set(func_, free_func_));
}

inline void elm::slider::units_format_function_set(slider_func_type func_, slider_freefunc_type free_func_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_units_format_function_set(func_, free_func_));
}

inline bool eo_cxx::elm::slider::horizontal_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_horizontal_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::slider::horizontal_set(bool horizontal_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_horizontal_set(::efl::eolian::to_c(horizontal_)));
}

inline double eo_cxx::elm::slider::value_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_value_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::slider::value_set(double val_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_value_set(val_));
}

inline ::efl::eina::optional< ::efl::eina::string_view > eo_cxx::elm::slider::indicator_format_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_format_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::slider::indicator_format_set(::efl::eina::optional< ::efl::eina::string_view > indicator_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_indicator_format_set(::efl::eolian::to_c(indicator_)));
}

inline bool eo_cxx::elm::slider::inverted_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_inverted_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::slider::inverted_set(bool inverted_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_inverted_set(::efl::eolian::to_c(inverted_)));
}

inline bool eo_cxx::elm::slider::indicator_show_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_show_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::slider::indicator_show_set(bool show_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_indicator_show_set(::efl::eolian::to_c(show_)));
}

inline void eo_cxx::elm::slider::min_max_get(double* min_, double* max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_min_max_get(min_, max_));
}

inline void eo_cxx::elm::slider::min_max_set(double min_, double max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_min_max_set(min_, max_));
}

inline ::efl::eina::optional< ::efl::eina::string_view > eo_cxx::elm::slider::unit_format_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_unit_format_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::slider::unit_format_set(::efl::eina::optional< ::efl::eina::string_view > units_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_unit_format_set(::efl::eolian::to_c(units_)));
}

inline bool eo_cxx::elm::slider::indicator_show_on_focus_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_show_on_focus_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::slider::indicator_show_on_focus_set(bool flag_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_indicator_show_on_focus_set(::efl::eolian::to_c(flag_)));
}

inline Evas_Coord eo_cxx::elm::slider::span_size_get() const
{
   Evas_Coord _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_span_size_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::slider::span_size_set(Evas_Coord size_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_span_size_set(size_));
}

inline double eo_cxx::elm::slider::step_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_step_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::slider::step_set(double step_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_step_set(step_));
}

inline Elm_Slider_Indicator_Visible_Mode eo_cxx::elm::slider::indicator_visible_mode_get() const
{
   Elm_Slider_Indicator_Visible_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_visible_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::slider::indicator_visible_mode_set(Elm_Slider_Indicator_Visible_Mode indicator_visible_mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_indicator_visible_mode_set(indicator_visible_mode_));
}

inline void eo_cxx::elm::slider::indicator_format_function_set(slider_func_type func_, slider_freefunc_type free_func_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_indicator_format_function_set(func_, free_func_));
}

inline void eo_cxx::elm::slider::units_format_function_set(slider_func_type func_, slider_freefunc_type free_func_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_slider_units_format_function_set(func_, free_func_));
}

inline ::eo_cxx::elm::slider::operator ::elm::slider() const
{
   return *static_cast<::elm::slider const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::slider::operator ::elm::slider&()
{
   return *static_cast<::elm::slider*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::slider::operator ::elm::slider const&() const
{
   return *static_cast<::elm::slider const*>(static_cast<void const*>(this));
}

template <typename T>
bool elm_slider_horizontal_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->horizontal_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_slider_horizontal_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool horizontal_)
{
   try
      {
         static_cast<T*>(self->this_)->horizontal_set(::efl::eolian::to_cxx<bool>(horizontal_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double elm_slider_value_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->value_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_slider_value_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double val_)
{
   try
      {
         static_cast<T*>(self->this_)->value_set(val_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::optional< ::efl::eina::string_view > elm_slider_indicator_format_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->indicator_format_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_slider_indicator_format_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * indicator_)
{
   try
      {
         static_cast<T*>(self->this_)->indicator_format_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(indicator_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_slider_inverted_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->inverted_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_slider_inverted_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool inverted_)
{
   try
      {
         static_cast<T*>(self->this_)->inverted_set(::efl::eolian::to_cxx<bool>(inverted_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_slider_indicator_show_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->indicator_show_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_slider_indicator_show_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool show_)
{
   try
      {
         static_cast<T*>(self->this_)->indicator_show_set(::efl::eolian::to_cxx<bool>(show_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_slider_min_max_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double* min_, double* max_)
{
   try
      {
         static_cast<T*>(self->this_)->min_max_get(min_, max_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_slider_min_max_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double min_, double max_)
{
   try
      {
         static_cast<T*>(self->this_)->min_max_set(min_, max_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::optional< ::efl::eina::string_view > elm_slider_unit_format_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->unit_format_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_slider_unit_format_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * units_)
{
   try
      {
         static_cast<T*>(self->this_)->unit_format_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(units_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_slider_indicator_show_on_focus_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->indicator_show_on_focus_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_slider_indicator_show_on_focus_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool flag_)
{
   try
      {
         static_cast<T*>(self->this_)->indicator_show_on_focus_set(::efl::eolian::to_cxx<bool>(flag_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_Coord elm_slider_span_size_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->span_size_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_Coord _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_slider_span_size_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord size_)
{
   try
      {
         static_cast<T*>(self->this_)->span_size_set(size_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double elm_slider_step_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->step_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_slider_step_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double step_)
{
   try
      {
         static_cast<T*>(self->this_)->step_set(step_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Slider_Indicator_Visible_Mode elm_slider_indicator_visible_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->indicator_visible_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Slider_Indicator_Visible_Mode _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_slider_indicator_visible_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Slider_Indicator_Visible_Mode indicator_visible_mode_)
{
   try
      {
         static_cast<T*>(self->this_)->indicator_visible_mode_set(indicator_visible_mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_slider_indicator_format_function_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, slider_func_type func_, slider_freefunc_type free_func_)
{
   try
      {
         static_cast<T*>(self->this_)->indicator_format_function_set(func_, free_func_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_slider_units_format_function_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, slider_func_type func_, slider_freefunc_type free_func_)
{
   try
      {
         static_cast<T*>(self->this_)->units_format_function_set(func_, free_func_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::slider >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::elm_interface_atspi_value >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
   {
      virtual bool horizontal_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_horizontal_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void horizontal_set(bool horizontal_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_horizontal_set(::efl::eolian::to_c(horizontal_)));
      }

      virtual double value_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_value_get());
            return _tmp_ret;
      }

      virtual void value_set(double val_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_value_set(val_));
      }

      virtual ::efl::eina::optional< ::efl::eina::string_view > indicator_format_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_indicator_format_get());
            return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void indicator_format_set(::efl::eina::optional< ::efl::eina::string_view > indicator_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_indicator_format_set(::efl::eolian::to_c(indicator_)));
      }

      virtual bool inverted_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_inverted_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void inverted_set(bool inverted_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_inverted_set(::efl::eolian::to_c(inverted_)));
      }

      virtual bool indicator_show_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_indicator_show_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void indicator_show_set(bool show_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_indicator_show_set(::efl::eolian::to_c(show_)));
      }

      virtual void min_max_get(double* min_, double* max_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_min_max_get(min_, max_));
      }

      virtual void min_max_set(double min_, double max_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_min_max_set(min_, max_));
      }

      virtual ::efl::eina::optional< ::efl::eina::string_view > unit_format_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_unit_format_get());
            return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void unit_format_set(::efl::eina::optional< ::efl::eina::string_view > units_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_unit_format_set(::efl::eolian::to_c(units_)));
      }

      virtual bool indicator_show_on_focus_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_indicator_show_on_focus_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void indicator_show_on_focus_set(bool flag_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_indicator_show_on_focus_set(::efl::eolian::to_c(flag_)));
      }

      virtual Evas_Coord span_size_get()
      {
         Evas_Coord _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_span_size_get());
            return _tmp_ret;
      }

      virtual void span_size_set(Evas_Coord size_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_span_size_set(size_));
      }

      virtual double step_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_step_get());
            return _tmp_ret;
      }

      virtual void step_set(double step_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_step_set(step_));
      }

      virtual Elm_Slider_Indicator_Visible_Mode indicator_visible_mode_get()
      {
         Elm_Slider_Indicator_Visible_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_indicator_visible_mode_get());
            return _tmp_ret;
      }

      virtual void indicator_visible_mode_set(Elm_Slider_Indicator_Visible_Mode indicator_visible_mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_indicator_visible_mode_set(indicator_visible_mode_));
      }

      virtual void indicator_format_function_set(slider_func_type func_, slider_freefunc_type free_func_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_indicator_format_function_set(func_, free_func_));
      }

      virtual void units_format_function_set(slider_func_type func_, slider_freefunc_type free_func_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_units_format_function_set(func_, free_func_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::slider >
{
   static constexpr int value = 
#if defined(SLIDER_PROTECTED) && defined(SLIDER_BETA)
      24
#elif defined(SLIDER_PROTECTED)
      24
#elif defined(SLIDER_BETA)
      24
#else
      24
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::elm_interface_atspi_value >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::slider>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_horizontal_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_horizontal_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_horizontal_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_horizontal_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_value_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_value_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_value_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_value_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_indicator_format_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_format_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_indicator_format_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_format_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_inverted_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_inverted_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_inverted_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_inverted_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_indicator_show_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_show_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_indicator_show_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_show_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_min_max_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_min_max_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_min_max_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_min_max_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_unit_format_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_unit_format_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_unit_format_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_unit_format_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_indicator_show_on_focus_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_show_on_focus_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_indicator_show_on_focus_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_show_on_focus_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_span_size_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_span_size_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_span_size_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_span_size_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_step_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_step_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_step_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_step_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_indicator_visible_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_visible_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_indicator_visible_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_visible_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_indicator_format_function_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_format_function_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_slider_units_format_function_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_units_format_function_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::slider >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_value>(), &ops[operation_description_class_size< ::elm::slider >::value + operation_description_class_size<::elm::layout>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::slider >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::elm_interface_atspi_value>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::slider>)
{
   return (ELM_SLIDER_CLASS);
}

} } }

/// @endcond

